//
//  EEViewController.m
//  EEAnimationHandlerSample
//
//  Created by Kudo Yoshiki on 12/07/24.
//  Copyright (c) 2012年 milestoneeee.com. All rights reserved.
//

#import "EEViewController.h"
#import "EEAnimationHandler.h"

@interface EEViewController ()

@end

@implementation EEViewController

@synthesize aView = _aView;

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

#pragma mark - Private
- (IBAction)turnArround:(id)sender
{
    CALayer *layer = self.aView.layer;
    
    CGFloat delta = 40.0;
    CGFloat duration = 1.5;
    
    CABasicAnimation *left;
    left = [CABasicAnimation animationWithKeyPath:@"position"];
    left.fromValue = [NSValue valueWithCGPoint:layer.position];
    left.toValue = [NSValue valueWithCGPoint:CGPointMake(layer.position.x - delta, layer.position.y)];
    left.duration = duration;
    left.fillMode = kCAFillModeForwards;
    left.removedOnCompletion = NO;
    left.stopHandlerBlock = ^(CAAnimation *anim, BOOL finished){
        
        CALayer *aLayer = anim.addedLayer;
        CALayer *pLayer = [aLayer presentationLayer];
        aLayer.position = pLayer.position;
        
//        NSLog(@"aLayer:%@", aLayer);
//        NSLog(@"pLayer:%@", pLayer);
//        NSLog(@"aLayer.position:%@", NSStringFromCGPoint(aLayer.position));
//        NSLog(@"pLayer.position:%@", NSStringFromCGPoint(pLayer.position));
        
        [aLayer removeAnimationForKey:anim.animationKey];
        
        // 上へ
        CABasicAnimation *up;
        up = [CABasicAnimation animationWithKeyPath:@"position"];
        up.fromValue = [NSValue valueWithCGPoint:layer.position];
        up.toValue = [NSValue valueWithCGPoint:CGPointMake(layer.position.x, layer.position.y - delta)];
        up.duration = duration;
        up.fillMode = kCAFillModeForwards;
        up.removedOnCompletion = NO;
        up.stopHandlerBlock = ^(CAAnimation *anim, BOOL finished){
            
            CALayer *aLayer = anim.addedLayer;
            CALayer *pLayer = [aLayer presentationLayer];
            aLayer.position = pLayer.position;
            
            [aLayer removeAnimationForKey:anim.animationKey];
            
            // 右へ
            CABasicAnimation *right;
            right = [CABasicAnimation animationWithKeyPath:@"position"];
            right.fromValue = [NSValue valueWithCGPoint:layer.position];
            right.toValue = [NSValue valueWithCGPoint:CGPointMake(layer.position.x + delta, layer.position.y)];
            right.duration = duration;
            right.fillMode = kCAFillModeForwards;
            right.removedOnCompletion = NO;
            right.stopHandlerBlock = ^(CAAnimation *anim, BOOL finished){
                
                CALayer *aLayer = anim.addedLayer;
                CALayer *pLayer = [aLayer presentationLayer];
                aLayer.position = pLayer.position;
                
                [aLayer removeAnimationForKey:anim.animationKey];
                
                // 下へ
                CABasicAnimation *bottom;
                bottom = [CABasicAnimation animationWithKeyPath:@"position"];
                bottom.fromValue = [NSValue valueWithCGPoint:layer.position];
                bottom.toValue = [NSValue valueWithCGPoint:CGPointMake(layer.position.x, layer.position.y + delta)];
                bottom.duration = duration;
                bottom.fillMode = kCAFillModeForwards;
                bottom.removedOnCompletion = NO;
                bottom.stopHandlerBlock = ^(CAAnimation *anim, BOOL finished){
                    
                    CALayer *aLayer = anim.addedLayer;
                    CALayer *pLayer = [aLayer presentationLayer];
                    aLayer.position = pLayer.position;
                    
                    [aLayer removeAnimationForKey:anim.animationKey];
                };
                
                EEAnimationHandler *handler = [EEAnimationHandler sharedHandler];
                [handler registerAnimation:bottom toLayer:self.aView.layer forKey:@"bottom"];
            };
            
            EEAnimationHandler *handler = [EEAnimationHandler sharedHandler];
            [handler registerAnimation:right toLayer:self.aView.layer forKey:@"right"];
        };
        
        EEAnimationHandler *handler = [EEAnimationHandler sharedHandler];
        [handler registerAnimation:up toLayer:self.aView.layer forKey:@"up"];
    };
    
    EEAnimationHandler *handler = [EEAnimationHandler sharedHandler];
    [handler registerAnimation:left toLayer:self.aView.layer forKey:@"left"];
}

@end
