EEAnimationHandler
==================

Core Animation Handler (switch delegate method to blocks)  

Feature
--------------------
+ Singleton  
+ ARC  

Installation
--------------------
1) copy `EEAnimationHandler.h(.m)`  
2) add `QuartzCore` framework  

How To
--------------------
### ex. ###
	CABasicAnimation *move;
	move = [CABasicAnimation animationWithKeyPath:@"position"];
	move.fromValue = [NSValue valueWithCGPoint:layer.position];
	move.toValue = [NSValue valueWithCGPoint:toPosition];
	move.duration = 1.0;
	move.fillMode = kCAFillModeForwards;
	move.removedOnCompletion = NO;
    move.stopHandlerBlock = ^(CAAnimation *anim, BOOL finished){
        
        CALayer *aLayer = anim.addedLayer;
        CALayer *pLayer = [aLayer presentationLayer];
        aLayer.position = pLayer.position;

        [aLayer removeAnimationForKey:anim.animationKey];
        ...

    };

	EEAnimationHandler *handler = [EEAnimationHandler sharedHandler];
	[handler registerAnimation:move toLayer:layer forKey:animationKey];

1) make animation object  
2) (option) implement `^stopHandlerBlock(CAAnimation *anim, BOOL finished)` and `^startHandlerBlock(CAAnimation *anim)`  
*these blocks are called timing to be called delegate method  
3) call `+(void)sharedHandler` to get Singleton Instance  
4) add animation queue to call `- (void)registerAnimation:toLayer:forKey:`  

+ animation will be excited one after another.  
+ added some property in CAAnimation Category (ex. `addedLayer` is added CALayer object. `animationKey` is key Object (NSString). this is forKey argument `- (void)addAnimation:forKey:`)  

License
------------------
Copyright ©2012 Yoshiki Kudo All Rights Reserved.  
Distributed under the [MIT License][mit].

[MIT]: http://www.opensource.org/licenses/mit-license.php
